libzypp: zypp::pool::PoolImpl Class Reference

libzypp 17.38.5

zypp::pool::PoolImpl Class Reference

`#include <zypp/pool/PoolImpl.h>`

## Public Types
using | ContainerT = PoolTraits::ItemContainerT
using | size_type = PoolTraits::size_type
using | const_iterator = PoolTraits::const_iterator
using | Id2ItemT = PoolTraits::Id2ItemT
using | repository_iterator = PoolTraits::repository_iterator
using | SolvableIdType = sat::detail::SolvableIdType
using | EstablishedStatesImpl = ResPool::EstablishedStates::Impl

## Public Member Functions
| PoolImpl ()
| Default ctor.
| ~PoolImpl ()
| Dtor.
const sat::Pool | satpool () const
| convenience.
const SerialNumber & | serial () const
| Housekeeping data serial number.
bool | empty () const
size_type | size () const
const_iterator | begin () const
const_iterator | end () const
PoolItem | find (const sat::Solvable &slv_r) const
| Return the corresponding PoolItem.

## Friends
std::ostream & | operator<< (std::ostream &str, const PoolImpl &obj)

## Save and restore state.
using | HardLockQueries = PoolTraits::HardLockQueries
using | hardLockQueries_iterator = PoolTraits::hardLockQueries_iterator
SerialNumberWatcher | _watcher
| Watch sat pools serial number.
SerialNumberWatcher | _watcherIDs
| Watch sat pools Serial number of IDs - changes whenever resusePoolIDs==true - ResPool must also invalidate its PoolItems!
ContainerT | _store
DefaultIntegral< bool, true > | _storeDirty
Id2ItemT | _id2item
DefaultIntegral< bool, true > | _id2itemDirty
shared_ptr< ResPoolProxy > | _poolProxy
shared_ptr< EstablishedStatesImpl > | _establishedStates
HardLockQueries | _hardLockQueries
| Set of queries that define hardlocks.
void | SaveState (const ResKind &kind_r)
void | RestoreState (const ResKind &kind_r)
ResPoolProxy | proxy (ResPool self) const
ResPool::EstablishedStates | establishedStates () const
| True factory for ResPool::EstablishedStates.
size_type | knownRepositoriesSize () const
| Forward list of Repositories that contribute ResObjects from sat::Pool.
repository_iterator | knownRepositoriesBegin () const
repository_iterator | knownRepositoriesEnd () const
Repository | reposFind (const std::string &alias_r) const
const HardLockQueries & | hardLockQueries () const
void | reapplyHardLocks () const
void | setHardLockQueries (const HardLockQueries &newLocks_r)
bool | getHardLockQueries (HardLockQueries &activeLocks_r)
const ContainerT & | store () const
const Id2ItemT & | id2item () const
void | checkSerial () const
void | invalidate () const

## Detailed Description

Definition at line 168 of file PoolImpl.h.

## Member Typedef Documentation

## ◆ ContainerT

using zypp::pool::PoolImpl::ContainerT = PoolTraits::ItemContainerT

Definition at line 174 of file PoolImpl.h.

## ◆ size_type

using zypp::pool::PoolImpl::size_type = PoolTraits::size_type

Definition at line 175 of file PoolImpl.h.

## ◆ const_iterator

using zypp::pool::PoolImpl::const_iterator = PoolTraits::const_iterator

Definition at line 176 of file PoolImpl.h.

## ◆ Id2ItemT

using zypp::pool::PoolImpl::Id2ItemT = PoolTraits::Id2ItemT

Definition at line 177 of file PoolImpl.h.

## ◆ repository_iterator

using zypp::pool::PoolImpl::repository_iterator = PoolTraits::repository_iterator

Definition at line 179 of file PoolImpl.h.

## ◆ SolvableIdType

using zypp::pool::PoolImpl::SolvableIdType = sat::detail::SolvableIdType

Definition at line 181 of file PoolImpl.h.

## ◆ EstablishedStatesImpl

using zypp::pool::PoolImpl::EstablishedStatesImpl = ResPool::EstablishedStates::Impl

Definition at line 183 of file PoolImpl.h.

## ◆ HardLockQueries

using zypp::pool::PoolImpl::HardLockQueries = PoolTraits::HardLockQueries

Definition at line 281 of file PoolImpl.h.

## ◆ hardLockQueries_iterator

using zypp::pool::PoolImpl::hardLockQueries_iterator = PoolTraits::hardLockQueries_iterator

Definition at line 282 of file PoolImpl.h.

## Constructor & Destructor Documentation

## ◆ PoolImpl()

zypp::pool::PoolImpl::PoolImpl | ( |  | ) |

Default ctor.

Definition at line 44 of file PoolImpl.cc.

## ◆ ~PoolImpl()

zypp::pool::PoolImpl::~PoolImpl | ( |  | ) |

Dtor.

Definition at line 52 of file PoolImpl.cc.

## Member Function Documentation

## ◆ satpool()

const sat::Pool zypp::pool::PoolImpl::satpool | ( |  | ) | const
| inline

convenience.

Definition at line 193 of file PoolImpl.h.

## ◆ serial()

const SerialNumber & zypp::pool::PoolImpl::serial | ( |  | ) | const
| inline

Housekeeping data serial number.

Definition at line 197 of file PoolImpl.h.

## ◆ empty()

bool zypp::pool::PoolImpl::empty | ( |  | ) | const
| inline

Definition at line 205 of file PoolImpl.h.

## ◆ size()

size_type zypp::pool::PoolImpl::size | ( |  | ) | const
| inline

Definition at line 209 of file PoolImpl.h.

## ◆ begin()

const_iterator zypp::pool::PoolImpl::begin | ( |  | ) | const
| inline

Definition at line 212 of file PoolImpl.h.

## ◆ end()

const_iterator zypp::pool::PoolImpl::end | ( |  | ) | const
| inline

Definition at line 215 of file PoolImpl.h.

## ◆ find()

PoolItem zypp::pool::PoolImpl::find | ( | const sat::Solvable & | slv_r | ) | const
| inline

Return the corresponding PoolItem.

Pool and sat pool should be in sync. Returns an empty PoolItem if there is no corresponding PoolItem.

See also
  PoolItem::satSolvable.

Definition at line 224 of file PoolImpl.h.

## ◆ SaveState()

void zypp::pool::PoolImpl::SaveState | ( | const ResKind & | kind_r | ) |

## ◆ RestoreState()

void zypp::pool::PoolImpl::RestoreState | ( | const ResKind & | kind_r | ) |

## ◆ proxy()

ResPoolProxy zypp::pool::PoolImpl::proxy | ( | ResPool | self | ) | const
| inline

Definition at line 245 of file PoolImpl.h.

## ◆ establishedStates()

ResPool::EstablishedStates zypp::pool::PoolImpl::establishedStates | ( |  | ) | const
| inline

True factory for ResPool::EstablishedStates.

Internally we maintain the ResPool::EstablishedStates::Impl reference shared_ptr. Updated whenever the pool content changes. On demand hand it out as ResPool::EstablishedStates Impl.

Definition at line 260 of file PoolImpl.h.

## ◆ knownRepositoriesSize()

size_type zypp::pool::PoolImpl::knownRepositoriesSize | ( |  | ) | const
| inline

Forward list of Repositories that contribute ResObjects from sat::Pool.

Definition at line 265 of file PoolImpl.h.

## ◆ knownRepositoriesBegin()

repository_iterator zypp::pool::PoolImpl::knownRepositoriesBegin | ( |  | ) | const
| inline

Definition at line 268 of file PoolImpl.h.

## ◆ knownRepositoriesEnd()

repository_iterator zypp::pool::PoolImpl::knownRepositoriesEnd | ( |  | ) | const
| inline

Definition at line 271 of file PoolImpl.h.

## ◆ reposFind()

Repository zypp::pool::PoolImpl::reposFind | ( | const std::string & | alias_r | ) | const
| inline

Definition at line 274 of file PoolImpl.h.

## ◆ hardLockQueries()

const HardLockQueries & zypp::pool::PoolImpl::hardLockQueries | ( |  | ) | const
| inline

Definition at line 284 of file PoolImpl.h.

## ◆ reapplyHardLocks()

void zypp::pool::PoolImpl::reapplyHardLocks | ( |  | ) | const
| inline

Definition at line 287 of file PoolImpl.h.

## ◆ setHardLockQueries()

void zypp::pool::PoolImpl::setHardLockQueries | ( | const HardLockQueries & | newLocks_r | ) |
| inline

Definition at line 308 of file PoolImpl.h.

## ◆ getHardLockQueries()

bool zypp::pool::PoolImpl::getHardLockQueries | ( | HardLockQueries & | activeLocks_r | ) |
| inline

Definition at line 329 of file PoolImpl.h.

## ◆ store()

const ContainerT & zypp::pool::PoolImpl::store | ( |  | ) | const
| inline

Definition at line 370 of file PoolImpl.h.

## ◆ id2item()

const Id2ItemT & zypp::pool::PoolImpl::id2item | ( |  | ) | const
| inline

Definition at line 431 of file PoolImpl.h.

## ◆ checkSerial()

void zypp::pool::PoolImpl::checkSerial | ( |  | ) | const
| inlineprivate

Definition at line 456 of file PoolImpl.h.

## ◆ invalidate()

void zypp::pool::PoolImpl::invalidate | ( |  | ) | const
| inlineprivate

Definition at line 463 of file PoolImpl.h.

## Friends And Related Symbol Documentation

## ◆ operator<<

std::ostream & operator<< | ( | std::ostream & | str,
|  | const PoolImpl & | obj )
| friend

## Member Data Documentation

## ◆ _watcher

SerialNumberWatcher zypp::pool::PoolImpl::_watcher
| private

Watch sat pools serial number.

Definition at line 474 of file PoolImpl.h.

## ◆ _watcherIDs

SerialNumberWatcher zypp::pool::PoolImpl::_watcherIDs
| private

Watch sat pools Serial number of IDs - changes whenever resusePoolIDs==true - ResPool must also invalidate its PoolItems!

Definition at line 476 of file PoolImpl.h.

## ◆ _store

ContainerT zypp::pool::PoolImpl::_store
| mutableprivate

Definition at line 477 of file PoolImpl.h.

## ◆ _storeDirty

DefaultIntegral<bool,true> zypp::pool::PoolImpl::_storeDirty
| mutableprivate

Definition at line 478 of file PoolImpl.h.

## ◆ _id2item

Id2ItemT zypp::pool::PoolImpl::_id2item
| mutableprivate

Definition at line 479 of file PoolImpl.h.

## ◆ _id2itemDirty

DefaultIntegral<bool,true> zypp::pool::PoolImpl::_id2itemDirty
| mutableprivate

Definition at line 480 of file PoolImpl.h.

## ◆ _poolProxy

shared_ptr<ResPoolProxy> zypp::pool::PoolImpl::_poolProxy
| mutableprivate

Definition at line 483 of file PoolImpl.h.

## ◆ _establishedStates

shared_ptr<EstablishedStatesImpl> zypp::pool::PoolImpl::_establishedStates
| mutableprivate

Definition at line 484 of file PoolImpl.h.

## ◆ _hardLockQueries

HardLockQueries zypp::pool::PoolImpl::_hardLockQueries
| private

Set of queries that define hardlocks.

Definition at line 488 of file PoolImpl.h.

The documentation for this class was generated from the following files:

- zypp/pool/PoolImpl.h
- zypp/pool/PoolImpl.cc